; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 640
WINDOWHEIGHT = 480
xrot	equ rot
yrot	equ rot+4
zrot	equ rot+8
xrotspeed	equ speed
yrotspeed	equ speed+4
zrotspeed	equ speed+4
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
TEXTURE_IMAGE struct
  sizeX		dd ?; Width Of Image In Pixels
  sizeY		dd ?; Height Of Image In Pixels
  data_		dd ?; Texture Data
TEXTURE_IMAGE ends

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
	cmp	edx,WM_TIMER
	je	wmTIMER
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
        invoke	KillTimer,hWin,10

	invoke	RtlExitUserProcess,NULL
;------------------------------
wmTIMER:movaps	xmm0,rot; update X and Y rotation angle by xrotspeed and yrotspeed
	addps	xmm0,speed
	movaps	rot,xmm0;xrot+=xspeed; 
        invoke	InvalidateRect,,0,0
	jmp	wmBYE
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'? 1Bh
	je	wmDESTROY
	cmp	al,VK_A;31h
	jne	@f
	movss	xmm0,zoom
	addss	xmm0,const0_05
	jmp	@1
@@:	cmp	al,VK_Z;34h
	jne	@f
	movss	xmm0,zoom
	subss	xmm0,const0_05
@1:	movss	zoom,xmm0
	jmp	@0
@@:	cmp	al,VK_RIGHT;27h
	jne	@f
	movss	xmm0,yrotspeed
	addss	xmm0,const0_08
	jmp	@2
@@:	cmp	al,VK_LEFT;25h
	jne	@f
	movss	xmm0,yrotspeed
	subss	xmm0,const0_08
@2:	movss	yrotspeed,xmm0
	jmp	@0
@@:	cmp	al,VK_DOWN;28h
	jne	@f
	movss	xmm0,xrotspeed
	addss	xmm0,const0_08
	jmp	@3
@@:	cmp	al,VK_UP;26h
	jne	@f
	movss	xmm0,xrotspeed
	subss	xmm0,const0_08
@3:	movss	xrotspeed,xmm0
	jmp	@0
;	if (keys[VK_PRIOR])	height +=0.03 Page Up Key Pressed Move Ball Up
;	if (keys[VK_NEXT])	height -=0.03 Page Down Key Pressed Move Ball Down
@@:	cmp	al,VK_PRIOR;21h
	jne	@f
	movss	xmm0,height
	addss	xmm0,const0_03
	jmp	@4
@@:	cmp	al,VK_NEXT;22h
	jne	wmBYE
	movss	xmm0,height
	subss	xmm0,const0_03
@4:	movss	height,xmm0
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
;-------------------------------------------------------
	invoke	LoadGLTextures; If Loading The Textures Failed
	invoke	glShadeModel,GL_SMOOTH;	 Enables Smooth Color Shading
	movss	xmm3,const1
	movss	xmm2,xmm3
	movss	xmm1,const0_5
	movss	xmm0,const0_2
	invoke	glClearColor;(0.2, 0.5, 1.0, 1.0 This Will Clear The Background Color To Black
        cvtss2sd xmm0,const1
	invoke	glClearDepth;(1.0);		 Enables Clearing Of The Depth Buffer
	invoke	glClearStencil,0; Clear The Stencil Buffer To 0
	invoke	glEnable,GL_DEPTH_TEST;	 Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST; Really Nice Perspective Calculations
	invoke	glEnable,GL_TEXTURE_2D; Enable 2D Texture Mapping
	mov	r8d,offset LightAmb
	invoke	glLightfv,GL_LIGHT0,GL_AMBIENT; Set The Ambient Lighting For Light0
	mov	r8d,offset LightDif
	invoke	glLightfv,GL_LIGHT0,GL_DIFFUSE; Set The Diffuse Lighting For Light0
	mov	r8d,offset LightPos
	invoke	glLightfv,GL_LIGHT0,GL_POSITION; Set The Position For Light0

	invoke	glEnable,GL_LIGHT0; Enable Light 0
	invoke	glEnable,GL_LIGHTING; Enable Lighting
	invoke	gluNewQuadric; Create A New Quadratic
	mov	q,rax 
	invoke	gluQuadricNormals,eax,GL_SMOOTH; Generate Smooth Normals For The Quad
	invoke	gluQuadricTexture,q, GL_TRUE; Enable Texture Coords For The Quad

	invoke	glTexGeni,GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP; Set Up Sphere Mapping
	invoke	glTexGeni,GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP; Set Up Sphere Mapping


	mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear The Screen And The Depth Buffer
; Clip Plane Equations
;	double eqr[] = {0.0f,-1.0f, 0.0f, 0.0f};			// Plane Equation To Use For The Reflected Objects

	invoke	glLoadIdentity;	 Reset The View
	movss	xmm2,zoom
	movss	xmm1,const_0_6
	xorps	xmm0,xmm0
	invoke	glTranslatef;0, -0.6, zoom Zoom And Raise Camera Above The Floor (Up 0.6 Units)
	invoke	glColorMask,0,0,0,0;								// Set Color Mask
	invoke	glEnable,GL_STENCIL_TEST; Enable Stencil Buffer For "marking" The Floor
	invoke	glStencilFunc,GL_ALWAYS, 1, 1;						// Always Passes, 1 Bit Plane, 1 As Mask
	invoke	glStencilOp,GL_KEEP,GL_KEEP,GL_REPLACE; We Set The Stencil Buffer To 1 Where We Draw Any Polygon
; Keep If Test Fails, Keep If Test Passes But Buffer Test Fails
; Replace If Test Passes
	invoke	glDisable,GL_DEPTH_TEST; Disable Depth Testing
	invoke	DrawFloor; Draw The Floor (Draws To The Stencil Buffer)
; We Only Want To Mark It In The Stencil Buffer
	invoke	glEnable,GL_DEPTH_TEST; Enable Depth Testing
	invoke	glColorMask,1,1,1,1; Set Color Mask to TRUE, TRUE, TRUE, TRUE
	invoke	glStencilFunc,GL_EQUAL, 1, 1; We Draw Only Where The Stencil Is 1
; (I.E. Where The Floor Was Drawn)
	invoke	glStencilOp,GL_KEEP, GL_KEEP, GL_KEEP; Don't Change The Stencil Buffer
	invoke	glEnable,GL_CLIP_PLANE0; Enable Clip Plane For Removing Artifacts
; (When The Object Crosses The Floor)
	mov	edx,offset eqr
	invoke	glClipPlane,GL_CLIP_PLANE0;					// Equation For Reflected Objects
	invoke	glPushMatrix; Push The Matrix Onto The Stack
	movss	xmm2,const1
	movss	xmm1,const_1
	movss	xmm0,xmm2
	invoke	glScalef;1, -1, 1 Mirror Y Axis
	mov	r8d,offset LightPos
	invoke	glLightfv,GL_LIGHT0, GL_POSITION; Set Up Light0
	xorps	xmm2,xmm2
	movss	xmm1,height
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f, height, 0.0f); Position The Object
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xrot
	invoke	glRotatef;(xrot, 1.0f, 0.0f, 0.0f); Rotate Local Coordinate System On X Axis
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,yrot
	invoke	glRotatef;(yrot, 0.0f, 1.0f, 0.0f); Rotate Local Coordinate System On Y Axis
	invoke	DrawObject; Draw The Sphere (Reflection)
	invoke	glPopMatrix; Pop The Matrix Off The Stack
	invoke	glDisable,GL_CLIP_PLANE0; Disable Clip Plane For Drawing The Floor
	invoke	glDisable,GL_STENCIL_TEST; We Don't Need The Stencil Buffer Any More (Disable)
	mov	r8d,offset LightPos
	invoke	glLightfv,GL_LIGHT0,GL_POSITION; Set Up Light0 Position
	invoke	glEnable,GL_BLEND; Enable Blending (Otherwise The Reflected Object Wont Show)
	invoke	glDisable,GL_LIGHTING; Since We Use Blending, We Disable Lighting
	movss	xmm3,const0_8
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor4f;(1.0f, 1.0f, 1.0f, 0.8f);					// Set Color To White With 80% Alpha
	invoke	glBlendFunc,GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA; Blending Based On Source Alpha And 1 Minus Dest Alpha
	invoke	DrawFloor; Draw The Floor To The Screen
	invoke	glEnable,GL_LIGHTING; Enable Lighting
	invoke	glDisable,GL_BLEND; Disable Blending
	xorps	xmm2,xmm2
	movss	xmm1,height
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f, height, 0.0f);					// Position The Ball At Proper Height
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,xrot
	invoke	glRotatef;(xrot, 1.0f, 0.0f, 0.0f);					// Rotate On The X Axis
	xorps	xmm3,xmm3
	movss	xmm2,const1
	xorps	xmm1,xmm1
	movss	xmm0,yrot
	invoke	glRotatef;(yrot, 0.0f, 1.0f, 0.0f);					// Rotate On The Y Axis
	invoke	DrawObject; Draw The Ball
;   
	invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn
WndProc	endp
LoadGLTextures proc
local	hFile:dword
local	FSize:dword
local	szReadWrite:dword	;number of bytes actually read or write
local	TextureImage[3]:TEXTURE_IMAGE
local	mem:dword
;    int Status=FALSE;									// Status Indicator
;    AUX_RGBImageRec *TextureImage[3];					// Create Storage Space For The Textures
;    memset(TextureImage,0,sizeof(void *)*3);			// Set The Pointer To NULL
	mov	edx,offset texture
	invoke	glGenTextures,3;Create The Texture
	xor	edi,edi
@@:	mov	ecx,FileName0[rdi*4]
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	hFile,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	mem,eax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
        invoke	CloseHandle,hFile
	mov	eax,[rsi + sizeof BITMAPFILEHEADER + BITMAPINFOHEADER.biWidth]
        mov	TextureImage[rdi*4].sizeX,eax
        movzx	eax, word ptr [rsi + sizeof BITMAPFILEHEADER + BITMAPINFOHEADER.biHeight]
        mov	TextureImage[rdi*4].sizeY,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]
	mov	TextureImage[rdi*4].data_,esi

;		for (int loop=0; loop<3; loop++)				// Loop Through 5 Textures
	mov	edx,texture[rdi*4]
	invoke	glBindTexture,GL_TEXTURE_2D;
	xor	edx,edx
	mov	r9d,TextureImage[rdi*4].sizeX
	mov	eax,TextureImage[rdi*4].sizeY
	mov	[rsp+20h],rax
	mov	[rsp+28h],rdx
	mov	qword ptr [rsp+30h],GL_BGR_EXT
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	eax,TextureImage[rdi*4].data_
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,,3
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	mov	ecx,mem
	invoke	GlobalFree
	inc	edi
	cmp	edi,3
	jb	@b
	leave
	ret
LoadGLTextures endp
DrawObject proc dummy:dword
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;(1.0f, 1.0f, 1.0f);						// Set Color To White
	mov	edx, texture[1*4]
	invoke	glBindTexture,GL_TEXTURE_2D;			// Select Texture 2 (1)
	movsd	xmm1,constd0_35
	invoke	gluSphere,q,, 32, 16;						// Draw First Sphere

	mov	edx, texture[2*4]
	invoke	glBindTexture,GL_TEXTURE_2D;			// Select Texture 3 (2)
	movss	xmm3,const0_4
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor4f;(1.0f, 1.0f, 1.0f, 0.4f);					// Set Color To White With 40% Alpha
	invoke	glEnable,GL_BLEND; Enable Blending
	invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE; Set Blending Mode To Mix Based On SRC Alpha
	invoke	glEnable,GL_TEXTURE_GEN_S; Enable Sphere Mapping
	invoke	glEnable,GL_TEXTURE_GEN_T; Enable Sphere Mapping

	movsd	xmm1,constd0_35
	invoke	gluSphere,q,,32,16; Draw Another Sphere Using New Texture
; Textures Will Mix Creating A MultiTexture Effect (Reflection)
	invoke	glDisable,GL_TEXTURE_GEN_S; Disable Sphere Mapping
	invoke	glDisable,GL_TEXTURE_GEN_T; Disable Sphere Mapping
	invoke	glDisable,GL_BLEND;	 Disable Blending
	leave
	ret
DrawObject endp
DrawFloor proc dummy:dword
        mov	edx,texture[0]
	invoke	glBindTexture,GL_TEXTURE_2D;			// Select Texture 1 (0)
	invoke	glBegin,GL_QUADS; Begin Drawing A Quad
	xorps	xmm2,xmm2
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glNormal3f;(0.0, 1.0, 0/ Normal Pointing Up
	movss	xmm1,const1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 1 Bottom Left Of Texture
	movss	xmm2,const2
	xorps	xmm1,xmm1
	movss	xmm0,const_2
	invoke	glVertex3f;-2, 0, 2 Bottom Left Corner Of Floor
			
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTexCoord2f;0, 0 Top Left Of Texture
	movss	xmm2,const_2
	xorps	xmm1,xmm1
	movss	xmm0,xmm2
	invoke	glVertex3f;-2, 0,-2 Top Left Corner Of Floor
			
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glTexCoord2f;1, 0 Top Right Of Texture
	movss	xmm2,const_2
	xorps	xmm1,xmm1
	movss	xmm0,const2
	invoke	glVertex3f; 2, 0,-2 Top Right Corner Of Floor
			
	movss	xmm1,const1
	movss	xmm0,xmm1
	invoke	glTexCoord2f;1, 1 Bottom Right Of Texture
	movss	xmm2,const2
	xorps	xmm1,xmm1
	movss	xmm0,const2
	invoke	glVertex3f;2, 0, 2 Bottom Right Corner Of Floor
	invoke	glEnd; Done Drawing The Quad
	leave
	ret
DrawFloor endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#26: Stencil & Reflection Tutorial",0
FileName	db "br_Rabbit3.cur",0
Ball		db "Ball.bmp",0
Envroll		db "EnvRoll.bmp",0
Envwall		db "EnvWall.bmp",0
FileName0	dd offset Envwall,offset Ball,offset Envroll
texture		dd ?,?,?
q		dq ?
zoom		dd -7.0
height		dd 2.0
LightAmb	dd 0.7, 0.7, 0.7, 1.0; Ambient Light
LightDif	dd 1.0, 1.0, 1.0, 1.0; Diffuse Light
LightPos	dd 4.0, 4.0, 6.0, 1.0; Light Position
eqr		dq   0,-1.0,   0,   0; Plane Equation To Use For The Reflected Objects
;-----------------------------
;float
const0_03 	dd 0.03
const0_05 	dd 0.05
const0_08 	dd 0.08
const0_2	dd 0.2
const0_4	dd 0.4
const0_5	dd 0.5
const_0_6 	dd -0.6
const0_8 	dd 0.8
const1		dd 1.0
const_1		dd -1.0
const2		dd 2.0
const_2		dd -2.0
;double
constd0_1	dq 0.1
constd0_35	dq 0.35
constd45	dq 45.0
constd100	dq 100.0
align 16
rot	dd 0,0,0,0;X and Y Rotation
speed	dd 0,0,0,0;X and Y Rotation Speed
end